module.exports = {

  componentWillMount: function() {
    return this.setState({
      componentName: null,
      componentOptions: [],
      componentTweaks: []
    });
  },

  // Component name getter and setter
  setComponentName: function(name) {
    return this.setState({
      componentName: name
    });
  },
  getComponentName: function() {
    return this.state.componentName;
  },

  // Component options getter and setter
  setComponentOptions: function(options) {
    if(!Array.isArray(options)) {
      options = [options];
    }

    return this.setState({
      componentOptions: options
    });
  },
  getComponentOptions: function() {
    var options = this.state.componentOptions;
    var output = '';

    options.map(function(option, i) {
      output += '--' + option;
      if(option != options[options.length -1]) {
        output += ' ';
      }
    });

    return output;
  },

  // Component tweaks getter and setter
  setComponentTweaks: function(tweaks) {
    if(!Array.isArray(tweaks)) {
      tweaks = [tweaks];
    }

    return this.setState({
      componentTweaks: tweaks
    });
  },
  getComponentTweaks: function() {
    var tweaks = this.state.componentTweaks;
    var output = '';

    tweaks.map(function(tweak) {
      output += '+' + tweak;
      if(tweak != tweaks[tweaks.length -1]) {
        output += ' ';
      }
    });
    
    return output;
  },

  // Function to generate the string for the className
  getGeneratedClassName: function() {
    var output = '';

    if(this.state.componentName) {
      output += this.getComponentName();
    }
    if(this.state.componentOptions.length > 0) {
      output += ' ' + this.getComponentOptions();
    }
    if(this.state.componentTweaks.length > 0) {
      output += ' ' + this.getComponentTweaks();
    }
    return output;
  }

}